-----------------------------------------------------------------------------------------------
-- Client Lua Script for GuildLink
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "AchievementsLib"
require "Apollo"
require "ChatSystemLib"
require "Window"
require "GameLib"
-----------------------------------------------------------------------------------------------
-- GuildLink Module Definition
-----------------------------------------------------------------------------------------------
local GuildLink = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants & vars
-----------------------------------------------------------------------------------------------
 
local ShowDebugInfos = false

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function GuildLink:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function GuildLink:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- GuildLink OnLoad
-----------------------------------------------------------------------------------------------
function GuildLink:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("GuildLink.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	Apollo.RegisterEventHandler("AchievementUpdated", 			"OnAchievementUpdated", self)

end

-----------------------------------------------------------------------------------------------
-- GuildLink OnDocLoaded
-----------------------------------------------------------------------------------------------
function GuildLink:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "GuildLinkForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- GuildLink Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

function GuildLink:OnAchievementUpdated(updatedAchievement)

	if updatedAchievement ~= nil then
	
		local complet = updatedAchievement:IsComplete()
		local result = "Haut Fait : [ " .. updatedAchievement:GetName() .. " ] accompli"
			
		if complet == true then
		
			self:SendToChan(result)
			if ShowDebugInfos == true then self:DebugChatLog(result) end

		end	
			
		
	end


end

function GuildLink:SendToChan(result)

	local message = "/g " .. result
	
	ChatSystemLib.Command(message)
	
end	


function GuildLink:DebugChatLog(data)

	Print (data)

end
-----------------------------------------------------------------------------------------------
-- GuildLinkForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function GuildLink:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function GuildLink:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- GuildLink Instance
-----------------------------------------------------------------------------------------------
local GuildLinkInst = GuildLink:new()
GuildLinkInst:Init()
